# coding: utf-8

from __future__ import absolute_import
from __future__ import unicode_literals

from django.test.testcases import TestCase

from m3_auth.config import Config


class ConfigTestCase(TestCase):

    """Проверка модуля config."""

    def test_config(self):
        """Проверка класса Config."""
        tuple_params = (
            ('tuple_param', 'tuple_value'),
        )
        # Проверка создания из кортежа
        config_from_tuple = Config(tuple_params)
        self.assertTrue(config_from_tuple)
        self.assertEqual(config_from_tuple.tuple_param, 'tuple_value')

        dict_params = {
            'param': 'value',
            'nested': {
                'nested_param': 'nested_value'
            }
        }
        # Проверка создания аргумента словаря
        config_dict_params = Config(dict_params)
        # Проверка создания из именованных аргументов
        config_kwargs = Config(**dict_params)

        for config in (config_dict_params, config_kwargs):
            self.assertTrue(repr(config))
            self.assertTrue(config)
            self.assertTrue(config.__nonzero__())
            self.assertEqual(config.param, 'value')
            self.assertIsInstance(config.nested, Config)
            self.assertEqual(config.nested.nested_param, 'nested_value')
            self.assertIsNone(config.undefined_key)
